# -*- coding: utf-8 -*-
#
#
# $Id: ussd.py,v 1.4 2004/08/02 06:51:44 hd Exp $
"""ʵGlobal Name ServiceDaemon
"""

from uss.message import gnspmsg
from uss.protocols import gnsp
from twisted.internet import reactor, protocol
from time import clock

class GNSServerProtocol(gnsp.GNSProtocol):
    """һUSSЭ鴦"""
    def connectionMade(self):
        """ˣʲô"""
        pass

    def on_gnsp_connect(self, message):
        """ͻconnect"""
        smessage = gnspmsg.GNSPMessage()
        smessage.setMsgName('connect_resp')
        smessage.body.setField('status',1)
        smessage.body.setField('version',1)
        self.sendData(smessage.packed())

    def on_gnsp_mail_counter(self, message):
        """ͻmail_counter"""
        smessage = gnspmsg.GNSPMessage()
        smessage.setMsgName('mail_counter_resp')
        smessage.body.setField('uid',message.body.fields['uid'])
        smessage.body.setField('number',2028)
        self.sendData(smessage.packed())

    def on_gnsp_terminate(self, message):
        """ͻterminate"""
        smessage = gnspmsg.GNSPMessage()
        smessage.setMsgName('terminate_resp')
        self.sendData(smessage.packed())

class GNSServerFactory(protocol.ServerFactory):
    """GNS"""
    protocol = GNSServerProtocol

def main():
    f = GNSServerFactory()
    reactor.listenTCP(7890, f)
    reactor.run()

if __name__ == "__main__":
    main()