# -*- coding: utf-8 -*-
#
#
# $Id: ussc.py,v 1.8 2004/08/03 07:41:15 hd Exp $
"""ʵUSSClient
"""

from uss.message import usspmsg
from uss.protocols import ussp
from twisted.internet import reactor, protocol, defer
from time import clock
import Queue

# ˻ڵĴС
WINMAX = 2048

class USSClientProtocol(ussp.USSClientQueueProtocol):
    """һUSSͻЭ鴦"""
    def connectionMade(self):
        """ӳɹʼͱ"""
        # ȷһconnectĽ
        message = usspmsg.USSPMessage()
        message.setMsgName('connect')
        message.body.setField('system_id','123456')
        message.body.setField('auth_source','1234567890123456')
        message.body.setField('version',0x0100)
        message.body.setField('time_stamp','12345678')
        self.sendDataToQueue(message)
        ussp.USSClientQueueProtocol.connectionMade(self)

    def on_ussp_connect_resp(self, message):
        """connectresp"""
        print "Connect successfully"
        defer.succeed(self.testserver())

    def on_ussp_terminate_resp(self, message):
        # ˣϿѾ
        self.transport.loseConnection()

    def on_ussp_mail_counter_resp(self, message):
        """mail_counterresp"""
        global getnum
        global lastuid
        lastuid = message.body.fields['uid']
        getnum += 1

    def testserver(self):
        """ĲԱ"""
        global nownum
        global count
        
        while nownum < count:
            message = usspmsg.USSPMessage()
            message.setMsgName('mail_counter')
            message.body.setField('uid',str(nownum))  
            if self.factory.sendQueue.full():       
                self.call = reactor.callLater(0, self.testserver)
                return 
            else:
                self.factory.sendQueue.put_nowait(message)
                nownum += 1

        self.disconnect()
    
    def disconnect(self):
        """Աĺterminate÷Ͽ"""
        message = usspmsg.USSPMessage()
        message.setMsgName('terminate')
        self.sendDataToQueue(message)

class USSClientFactory(protocol.ClientFactory):
    protocol = USSClientProtocol

    def __init__(self):
        # ڵĴС
        self.WINMAX = WINMAX
        # ȴ͵ıĶ
        self.sendQueue = Queue.Queue(self.WINMAX)
        # ѾıID
        self.sendMsg = []
        # ʹõϢID
        self.sequence = 1
        
    def clientConnectionFailed(self, connector, reason):
        print "Connection failed - goodbye!"
        reactor.stop()

    def clientConnectionLost(self, connector, reason):
        print "Connection lost"
        reactor.stop()
        pass

def main():
    f = USSClientFactory()
    global count
    count = 0xffff
    global nownum
    nownum = 0
    global lastuid
    lastuid = ''
    global getnum
    getnum = 0
    reactor.connectTCP("127.0.0.1", 7890, f)
    start = clock()
    reactor.run()
    print "ݣ%10d " %nownum
    print "յ %d " %getnum
    print "յuidΪ%s" %lastuid
    print "ʱ%.2f " %(clock()-start)
    print "ÿ룺%f" %(nownum / (clock()-start))

if __name__ == "__main__":
    main()