# -*- coding: utf-8 -*-
#
#
# $Id: ussd.py,v 1.4 2004/08/02 06:51:44 hd Exp $
"""ʵGlobal Name ServiceClient
"""
from uss.message import gnspmsg
from uss.protocols import gnsp
from twisted.internet import reactor, protocol, defer
from time import clock

class GNSClientProtocol(gnsp.GNSProtocol):
    """һUSSͻЭ鴦"""
    def connectionMade(self):
        """ӳɹʼͱ"""
        # ȷһconnectĽ
        message = gnspmsg.GNSPMessage()
        message.setMsgName('connect')
        message.body.setField('system_id','123456')
        message.body.setField('auth_source','1234567890123456')
        message.body.setField('version',0x0100)
        message.body.setField('time_stamp','12345678')
        self.sendData(message.packed())

    def on_gnsp_connect_resp(self, message):
        """connectresp"""
        # print "Connect successfully"
        defer.succeed(self.testserver())

    def on_gnsp_terminate_resp(self, message):
        # ˣϿѾ
        self.transport.loseConnection()

    def on_gnsp_mail_counter_resp(self, message):
        """mail_counterresp"""
        global getnum
        global lastuid
        lastuid = message.body.fields['uid']
        getnum += 1
        self.disconnect()

    def testserver(self):
        """ĲԱ"""
        global nownum
        message = gnspmsg.GNSPMessage()
        message.setMsgName('mail_counter')
        message.body.setField('uid',str(nownum))  
        self.sendData(message.packed())
        nownum += 1
    
    def disconnect(self):
        """Աĺterminate÷Ͽ"""
        message = gnspmsg.GNSPMessage()
        message.setMsgName('terminate')
        self.sendData(message.packed())

class GNSClientFactory(protocol.ClientFactory):
    protocol = GNSClientProtocol
        
    def clientConnectionFailed(self, connector, reason):
        global nownum
        global count
        if nownum < count:
            connector.connect()
        else:
            print "Connection failed - goodbye!"
            reactor.stop()


    def clientConnectionLost(self, connector, reason):
        global nownum
        global count
        if nownum < count:
            connector.connect()
        else:
            print "Connection lost"
            reactor.stop()

def main():
    f = GNSClientFactory()
    global count
    count = 0x1
    global nownum
    nownum = 0
    global lastuid
    lastuid = ''
    global getnum
    getnum = 0
    reactor.connectTCP("127.0.0.1", 7890, f)
    start = clock()
    reactor.run()
    print "ݣ%10d " %nownum
    print "յ %d " %getnum
    print "յuidΪ%s" %lastuid
    print "ʱ%.2f " %(clock()-start)
    print "ÿ룺%f" %(nownum / (clock()-start))

if __name__ == "__main__":
    main()