# -*- coding: utf-8 -*-
#
#
# $Id: gnsp.py,v 1.3 2004/08/03 07:41:51 hd Exp $

"""Open Global Name Service Protocol

Stability: None

@author: U{HD<mailto:hdcola@gmail.com>}

@see: Open Global Name Service Protocol淶
"""

from uss.protocols import byteprotocol
from uss.message import gnspmsg

class GNSProtocol(byteprotocol.ByteMessageProtocol):
    """ȱʡGNSЭʵ"""
    def MessageReceived(self,packet):
        """յһϢԸϢд"""
        message = gnspmsg.GNSPMessage()
        message.loadMessage(packet)
        self.MessageProcess(message)

    def MessageProcess(self, message):
        """ָķյϢ"""
        method = getattr(self , "on_gnsp_%s" % message.msgname, None)
        return method(message)