# -*- coding: utf-8 -*-
#
#
# $Id: ussp.py,v 1.3 2004/08/02 06:51:44 hd Exp $

"""Open Unified Storage System Protocol

Stability: None

@author: U{HD<mailto:hdcola@gmail.com>}

@see: Open Unified Storage System Protocol淶
"""
from uss.protocols import byteprotocol
from uss.message import usspmsg
from twisted.internet import reactor

class USSProtocol(byteprotocol.ByteMessageProtocol):
    """ȱʡUSSЭʵ"""
    def MessageReceived(self,packet):
        """յһϢԸϢд"""
        message = usspmsg.USSPMessage()
        message.loadMessage(packet)
        # print message
        self.MessageProcess(message)

    def MessageProcess(self, message):
        """ָķյϢ"""
        method = getattr(self , "on_ussp_%s" % message.msgname, None)
        return method(message)

class USSClientQueueProtocol(USSProtocol):
    """ʹûڶеUSSЭͻʵ"""

    def MessageReceived(self,packet):
        """յһϢȷϢǷѷͳϢ
        ǣӷϢϢȻִȥ
        """
        message = usspmsg.USSPMessage()
        message.loadMessage(packet)
        # print message
        # ϢӶ
        self.factory.sendMsg.remove(message.head.sequence)
        self.MessageProcess(message)

    def connectionMade(self):
        """ӳɹˣͿ߳"""
        reactor.callInThread(self.sendQueueMesg)

    def sendDataToQueue(self, message):
        """ϢͶ"""
        if(not self.factory.sendQueue.full()):
            self.factory.sendQueue.put(message)
        else:
            self.call = reactor.callLater(0, self.sendDataToQueue, message)

    def sendQueueMesg(self):
        """еϢͳȥ"""
        if (len(self.factory.sendMsg) < self.factory.WINMAX):
            while (not self.factory.sendQueue.empty()):
                message = self.factory.sendQueue.get()
                # ǰϢ˳
                message.head.sequence = self.factory.sequence
                self.sendData(message.packed())
                # Ѿ͵ϢѾ͵嵥
                self.factory.sendMsg.append(self.factory.sequence)
                self.factory.sequence += 1
        self.call = reactor.callLater(0, self.sendQueueMesg)